import numpy as np


def pastShock(Shock_Angle, M_inf, gamma):

    # M1_normal
    Mn_inf = M_inf * np.sin(Shock_Angle)

    # M2_normal
    Mn_2 = np.sqrt(((Mn_inf ** 2) + (2 / (gamma - 1))) / ((2 * gamma / (gamma - 1)) * (Mn_inf ** 2) - 1))

    # Deflection Angle
    cot = np.cos(Shock_Angle) / np.sin(Shock_Angle)
    theta_delta = np.arctan(2 * cot * (((M_inf ** 2) * (np.sin(Shock_Angle) ** 2)-1) / ((M_inf ** 2) * (gamma + np.cos(2 * Shock_Angle)) + 2)))

    # M past shock (M2)
    M_2 = Mn_2 / (np.sin(Shock_Angle - theta_delta))

    # Past Shock Velocity
    v = (2 / ((gamma - 1) * (M_2 ** 2)) + 1) ** (-0.5)

    # Past Shock Respective Velocity Components
    v_r  = v * np.cos(Shock_Angle - theta_delta)
    v_th = -v * np.sin(Shock_Angle - theta_delta)

    return np.array([v_r, v_th, Mn_inf, Mn_2, M_2, theta_delta])
